<?php
/**
 * Copyright 2013 Drexel University
 */
function get_wiki_file_path($filename, $include_filename = true)
{
    // returns the path the file should be found at
    $filename = filename_to_legal_characters($filename);
    $md5 = md5($filename);
    if ($include_filename == true) {
        return substr($md5, 0, 1) . '/' . substr($md5, 0, 2) . '/' . $filename;
    } else {
        return substr($md5, 0, 1) . '/' . substr($md5, 0, 2) . '/';
    }
}
function filename_to_legal_characters($filename)
{
    return preg_replace(array('/\s/', '/\.[\.]+/', '/[^\w_\.\-]/'), array('_', '.', ''), trim($filename));
}
function validate_filename($filename) {
    $valid = preg_match('^[a-zA-Z0-9_-]+(.[a-zA-Z0-9]+)*$', $filename);
    if ($valid === 1) {
        return true;
    } elseif ($valid === 0) {
        return false;
    } else {
        return null;
    }
}
function get_formatted_size($bytes)
{
    // set filesize in different units, depending on the size
    if ($bytes > 1024 * 1024 * 1024) {
        $filesize_units = "GiB";
        $filesize = round($bytes / (1024 * 1024 * 1024.0), 2);
    } elseif ($bytes > 1024 * 1024) {
        $filesize_units = "MiB";
        $filesize = round($bytes / (1024 * 1024.0), 2);
    } elseif ($bytes > 1024) {
        $filesize_units = "KiB";
        $filesize = round($bytes / (1024.0), 2);
    } else {
        $filesize_units = "bytes";
        $filesize = $bytes;
    }

    return $filesize . ' ' . $filesize_units;
}
function server_port_for_url($portNumber) {
    if ($portNumber == '') {
        return '';
    } else {
        return ":$portNumber";
    }
}
function htmlSafe($untrusted) {
    return htmlspecialchars($untrusted, $flags = ENT_QUOTES);
}