<?php

// For security reasons;
if (!defined('MEDIAWIKI')) {
    die();
}

// global variable used by the other extensions to check if this extension is installed
$RodsWiki = true;
$dir = dirname(__FILE__) . '/';
require_once($dir . "RodsWiki.config.php");

// data to connect to the IRODS server
$configDefaultIrodsHost = "";
$configDefaultIrodsPort = "";
$configDefaultIrodsUser = "";
$configDefaultIrodsPass = "";
$configDefaultIrodsResource = "";
$configDefaultIrodsRootPath = "";
$configDefaultIrodsZone = "";

/*

  ================================================================

  Taking credit

  ================================================================
 */

$wgExtensionCredits['RodsWiki'][] = array(
    'path' => __FILE__,
    'author' => $configAuthor,
    'name' => $configExtensionName,
    'version' => $configExtensionVersion,
    'descriptionmsg' => 'irods-desc',
    'url' => $configExtensionURL,
);

$wgExtensionMessagesFiles['RodsWikiMagic'] = $dir . 'RodsWiki.i18n.magic.php'; // Definition of magic words

/*
  ================================================================

  Special Page for showing Irods AVU data

  ================================================================
 */

$wgAutoloadClasses['SpecialRodsWiki'] = $dir . 'SpecialIrodsMetadataPage.php'; // Special Page that displays metadata for a given IRODS file
$wgExtensionMessagesFiles['RodsWiki'] = $dir . 'RodsWiki.i18n.php';
$wgExtensionMessagesFiles['RodsWikiAlias'] = $dir . 'RodsWiki.alias.php';
$wgSpecialPages['IrodsMetadataPage'] = 'SpecialRodsWiki'; // Define the class in the special page

/*
  ================================================================

  Special Page for upload

  ================================================================
 */

$wgAutoloadClasses['SpecialIrodsUploadPage'] = $dir . 'SpecialIrodsUploadPage.php'; // Special Page that displays metadata for a given IRODS file
$wgSpecialPages['SpecialIrodsUploadPage'] = 'SpecialIrodsUploadPage'; // Define the class in the special page

/*
  ================================================================

  Special Page for search

  ================================================================
 */

$wgAutoloadClasses['SpecialIrodsSearchPage'] = $dir . 'SpecialIrodsSearchPage.php'; // Special Page that displays metadata for a given IRODS file
$wgSpecialPages['SpecialIrodsSearchPage'] = 'SpecialIrodsSearchPage'; // Define the class in the special page

/*
  ================================================================

  Special Page for iRODS user management

  ================================================================
 */

$wgAutoloadClasses['SpecialIrodsUserManagement'] = $dir . 'SpecialIrodsUserManagement.php'; // Special Page that displays metadata for a given IRODS file
$wgSpecialPages['SpecialIrodsUserManagement'] = 'SpecialIrodsUserManagement'; // Define the class in the special page

/*
  ================================================================

  Special Page for iRODS File Download

  ================================================================
 */

$wgAutoloadClasses['SpecialIrodsFileDownload'] = $dir . 'SpecialIrodsFileDownload.php'; // Special Page that displays metadata for a given IRODS file
$wgSpecialPages['SpecialIrodsFileDownload'] = 'SpecialIrodsFileDownload'; // Define the class in the special page

/*
  ================================================================

  Special Page for Collection Browser

  ================================================================
 */

$wgAutoloadClasses['SpecialIrodsCollectionBrowser'] = $dir . 'SpecialIrodsCollectionBrowser.php'; // Special Page that contains the collection browser
$wgSpecialPages['SpecialIrodsCollectionBrowser'] = 'SpecialIrodsCollectionBrowser'; // Define the class in the special page

/*
  ================================================================

  Hooks for upload page and article save

  ================================================================
 */

//$wgHooks['UploadComplete'][] = 'RodsWikiHooks::onUploadComplete';

/* TODO: Is this necessary?
if ($configSaveArticlesOnIrods) {
    $wgHooks['ArticleSave'][] = 'RodsWikiHooks::onArticleSave';
    $wgHooks['ArticleDelete'][] = 'RodsWikiHooks::onArticleDelete';
    $wgHooks['ArticleRevisionUndeleted'][] = 'RodsWikiHooks::onArticleRevisionUndeleted';
}
*/

// avoid search page when I submit the convert forms
$IrodsConvertPage = filter_input(INPUT_GET, 'IrodsConvertPage');
$IrodsSelectFiles = filter_input(INPUT_GET, 'IrodsSelectFiles');
if (isset($IrodsConvertPage) || isset($IrodsSelectFiles)) {
    $title_get = filter_input(input_GEt, 'title');
    if (isset($title_get)) {
        unset($title_get);
    }
    $search_get = filter_input(INPUT_GET, 'search');
    if (isset($search_get)) {
        unset($search_get);
    }
    $title_post = filter_input(INPUT_POST, 'title');
    if (isset($title_post)) {
        unset($title_post);
    }
    $search_post = filter_input(INPUT_POST, 'search');
    if (isset($search_post)) {
        unset($search_post);
    }
}
/*
  ================================================================

  Implementing the {{#irods:image.jpg}} tag

  ================================================================
 */

$wgHooks['ParserFirstCallInit'][] = 'RodsWikiParsers::IrodsExtensionSetupParserFunction';
$wgHooks['BaseTemplateToolbox'][] = 'RodsWikiHooks::ToolboxAddUploadPage'; // include in toolbox
//$wgHooks['ParserAfterTidy'][] = "RodsWikiHooks::CreateFacebookHeadBlock";
/*
  ================================================================

  Including the other files

  ================================================================
 */

require_once 'RodsWiki.functions.php';
require_once 'RodsWiki.hooks.php';
require_once 'RodsWiki.parsers.php';

/*
  ================================================================

  Global Variables

  ================================================================
 */
$HtmlToBeAddedAfter = "";
$HtmlToBeAddedBefore = "";
$IrodsReportShown = false;
$arrs = array();
