<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

class SpecialIrodsCollectionBrowser extends SpecialPage {
    private $userHomeDir;
    private $irodsAccount;
    private $currentDir;

    function __construct() {
        require_once __DIR__ . '/RodsWiki.functions.php';
        parent::__construct('SpecialIrodsCollectionBrowser');
    }

    public function execute($par) {
        global $wgOut;
        $tmpOut = '';
        $IrodsAccount = getAccount();
        $this->irodsAccount = $IrodsAccount;
        $this->userHomeDir = new ProdsDir($IrodsAccount, "/{$this->irodsAccount->zone}/home/{$this->irodsAccount->user}");
        $this->currentDir = $this->userHomeDir;
        $this->setHeaders();
        $inputPath = filter_input(INPUT_GET, 'path');
        if (isset($inputPath)) {
            $this->currentDir = new ProdsDir($IrodsAccount, $inputPath);
        }
        // Accounting for when the current dir is "/"
        $parentPath = $this->currentDir->getParentPath();
        if ($parentPath == '\\') {
            // getParentPath() returns "\" instead of "/" on Windows.
            $parentPath = '/';
        }
        if (isset($parentPath)) {
            $tmpOut .= "* [{{fullurl:Special:{{PAGENAMEE}}|path=$parentPath}} &#46;&#46;] \n";
        }
        $currentPath = $this->currentDir->getPath();
        $tmpOut .= "* [{{fullurl:Special:{{PAGENAMEE}}|path=$currentPath}} &#46;] \n";
        $childDirArray = $this->currentDir->getChildDirs();
        foreach ($childDirArray as $childDir) {
            $tmpOut .= '* ' . $this::buildDirLink($childDir) . "\n";
        }
        $childFileArray = $this->currentDir->getChildFiles();
        foreach ($childFileArray as $childFile) {
            $tmpOut .= "&emsp;&emsp;[{{fullurl:Special:IrodsMetadataPage|filename=" . $childFile->getPath() . '}} ' . $childFile->getName() . "]\n";
            //$tmpOut .= '&emsp;&emsp;{{IRods|#|' . $childFile->getPath() . "}} at " . $childFile->getPath();
        }
        $wgOut->addWikiText($tmpOut);
    }

    // IMPORTANT: Make sure you know $dirToLink is sanitized.
    // It should only be used internally.
    protected function buildDirLink(ProdsDir $dirPath) {
        return '[{{fullurl:Special:{{PAGENAMEE}}|path=' . $dirPath->getPath() . '}} ' . $dirPath->getName() . ']';
    }
}