<?php
/**
 * Copyright 2013 Drexel University
 */
$attribute = filter_input(INPUT_GET, 'attribute'); //returns null if not set
if ($attribute == "") {
    $attribute = null; //TODO determine if unnecessary. Condition included for equivalency with older code.
}
$value = filter_input(INPUT_GET, 'value');
if ($value == "") {
    $value = null;
}
$units = filter_input(INPUT_GET, 'units');
if ($units == "") {
    $units = null;
}
$attribute_exact = filter_input(INPUT_GET, 'attribute_exact');
if (isset($attribute_exact)) {
    if ($attribute_exact == 'true') {
        $attribute_match = '=';
    } else {
        $attribute_match = 'like';
        $attribute = '%' . $attribute . '%';
    }
}
$value_exact = filter_input(INPUT_GET, 'value_exact');
if (isset($value_exact)) {
    if ($value_exact == 'true') {
        $value_match = '=';
    } else {
        $value_match = 'like';
        $value = '%' . $value . '%';
    }
}
$units_exact = filter_input(INPUT_GET, 'units_exact');
if (isset($units_exact)) {
    if ($units_exact == 'true') {
        $units_match = '=';
    } else {
        $units_match = 'like';
        $units = '%' . $units . '%';
    }
}

require_once 'irods/Prods.inc.php';
require_once 'RodsWiki.config.php';

// make an iRODS account object for connection
$account = new RODSAccount($configIrodsHost, $configIrodsPort, $configIrodsUser, $configIrodsPass);

$flds = array(
    'COL_DATA_NAME' => null,
    'COL_D_DATA_ID' => null,
    'COL_DATA_TYPE_NAME' => null,
    'COL_D_RESC_NAME' => null,
    'COL_DATA_SIZE' => null,
    'COL_D_OWNER_NAME' => null,
    'COL_D_OWNER_ZONE' => null,
    'COL_D_CREATE_TIME' => null,
    'COL_D_MODIFY_TIME' => null,
    'COL_COLL_NAME' => null,
    'COL_D_COMMENTS' => null
);

$select = new RODSGenQueSelFlds(array_keys($flds), array_values($flds));
$condition = new RODSGenQueConds();
$condition->add('COL_META_DATA_ATTR_NAME', $attribute_match, $attribute);
$condition->add('COL_META_DATA_ATTR_VALUE', $value_match, $value);
$condition->add('COL_META_DATA_ATTR_UNITS', $units_match, $units);
$condition->add('COL_COLL_NAME', 'like', $configIrodsRootPath . '%'); // recursive search

$conn = RODSConnManager::getConn($account);
$results = $conn->query($select, $condition, 0, -1);
RODSConnManager::releaseConn($conn);

$result_values = $results->getValues();

if (isset($result_values['COL_DATA_NAME']) && sizeof($result_values['COL_DATA_NAME']) > 0) {
    $scriptPathArray = explode('/', filter_input(INPUT_SERVER, 'SCRIPT_NAME'), 3);
    $wikiRootDir = $scriptPathArray[1];
    echo '<table width="100%">';
    echo '<tr align="left"><th>iRODS Filename</th><th>Date Created</th><th>Date Modified</th><th>iRODS Path</th></tr>';
    $sizeOfColDataName = sizeof($result_values['COL_DATA_NAME']);
    for ($i = 0; $i < $sizeOfColDataName; $i++) {
        echo "<tr><td><a href=\"http://"
            . filter_input(INPUT_SERVER, 'SERVER_NAME')
            . ':'
            . filter_input(INPUT_SERVER, 'SERVER_PORT')
            . '/'
            . $wikiRootDir
            . "/index.php/Special:IrodsMetadataPage?filename="
            . $result_values['COL_COLL_NAME'][$i]
            . '/'
            . $result_values['COL_DATA_NAME'][$i]
            . '">'
            . $result_values['COL_DATA_NAME'][$i]
            . "</a></td><td>"
            . date("Y-m-d H:i:s", $result_values['COL_D_CREATE_TIME'][$i])
            . "</td><td>"
            . date("Y-m-d H:i:s", $result_values['COL_D_MODIFY_TIME'][$i])
            . "</td><td>"
            . $result_values['COL_COLL_NAME'][$i]
            . "/"
            . $result_values['COL_DATA_NAME'][$i]
            . "</td></tr>"
        ;
    }
    echo '</table>';
} else {
    echo "No files found.";
}
